-- ConV Command line measurement conversion utility (second update)
-- (c)2001 Jim Roberts

    include get.e
    include convert.e

    sequence Usage, uf, cmd, res
     integer l
      object val

       uf = {}

    Usage = {
	      "ConV: Measurement conversion utility",
	      "(c)2001 Jim Roberts\n",
	      "Usage:",
	      "    ex conv.ex |-?| val from to\n",
	      "       -?: display this help text",
	      "      val: actual value to convert",
	      "     from: unit to convert from",
	      "       to: unit to convert to\n",
	      "Example:",
	      "    ex conv.ex 20 m/s mi/hr\n",
	      "    See unit.txt for a list of supported units.\n",
	      "This program was developed with Ephoria V2.2",
	      "(c)2000 Rapid Deployment Software",
	      "http:\\\\www.rapideuphoria.com\n",
	      "The user is free to modify and distribute this program.",
	      "If you incorporate this code into your own program,",
	      "please give credit to the author.\n"}

    for a=1 to length(Usage) do uf &="\n%s" end for

    cmd = command_line()
    cmd = cmd[3..length(cmd)]
      l = length(cmd)

    procedure usage()
	printf(1,uf,Usage)
	abort(0)
    end procedure

    procedure mismatch()
	printf(1,"\nCannot convert %s to %s\n",{cmd[2],cmd[3]})
	abort(0)
    end procedure

    procedure error()
	for a=1 to 2 do
	     if res[a] then
		printf(1,"\n%s is not a supported unit.\n",{cmd[1+a]})
	     end if
	end for
	puts(1,"\nSee unit.txt for supported units.\n")
	abort(0)
    end procedure

    if l<3 then usage() end if

    val = value(cmd[1])
    val = val[2]
    if not val then usage() end if

    res = convert_unit(val, cmd[2], cmd[3])

    if res[1]=-1 then mismatch() end if

    if find(1, res[1..2]) then error() end if

    printf(1,"\n %s %s ----> %g %s\n",{cmd[1],cmd[2],res[3],cmd[3]})

